// frame.c  (1190.bicyclesonthemoon.info/aftertime/frame)
// Dynamic frame for the viewer
// 06.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


#define STORYDEF_PRINTF "/eizm/data/aftertime/%s/settings"
#define MAWK_PATH "/usr/bin/mawk"
#define AWK_FRAME "/eizm/pro/aftertime/frame.awk"

#include <cgi.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

s_cgi *cgi;

int main (int argc, char *argv[])
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char *story;
	char *f;
	char *enh;
	
	char arg1[256];
	char arg2[256];
	char arg3[256];
	char storydef[256];
	
	cgi=cgiInit();
	
	//setvbuf(stdout, NULL, _IONBF, 0);
	// dup2(fileno(stdout),fileno(stderr));
	
	story=cgiGetValue(cgi,"story");
	f=cgiGetValue(cgi,"f");
	enh=cgiGetValue(cgi,"e");
	
	sprintf(arg1,"story=%s",story!=NULL ? story : "");
	sprintf(arg2,"frame=%s",f!=NULL ? f : "");
	sprintf(arg3,"enhance=%s",enh!=NULL ? enh : "");
	
	sprintf(storydef,STORYDEF_PRINTF,story!=NULL ? story : "time");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_FRAME,"-v",arg1,"-v",arg2,"-v",arg3,storydef,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
	{
		sprintf(storydef,STORYDEF_PRINTF,"default");
		fflush(stdout);
		sub=fork();
		if(sub==0)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_FRAME,"-v",arg1,"-v",arg2,"-v",arg3,storydef,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	
	return 0;
}
