#// ong.awk
#// The bot to ONG new frames to the viewer.
#// 09.06.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.


BEGIN{
	FS=""
	framepath="/eizm/www/time/"
	datapath="/eizm/data/aftertime/"
	
	timecmd="date +\"%H\""
	
	cp="/bin/cp"
	mawk="/usr/bin/mawk"
	bot4awk="/eizm/pro/aftertime/bot4.awk"
}
{
	file=1
	gsub(/[\r\n]/, "", $0)
	eq=index($0, "=")
	
	argtab[substr($0, 1, eq-1)]=substr($0, eq+1)
}
END{
	
	if (file=="")
		exit 1
	
	if(argtab["ongoing"]=="")
		exit 1
	
	timecmd | getline thistime
		close(timecmd)
	
	if(int(thistime) % int(argtab["ongtime"]) != 0)
		exit 1
	
	statefile= datapath argtab["story"]"/ongstate"
	getline temp < statefile
	close(statefile)
	
	split(temp, temptab, " ")
	state=int(temptab[1])
	last=int(temptab[2])
	
	if(state!=2)
		exit 1
	
	f=last+1
	if(argtab["last"]!="")
	{
		if (f==int(argtab["last"]))
			nextstate="3"
		else
			nextstate="1"
	}
	else
		nextstate="1"
	
	inframe= datapath argtab["story"]"/"sprintf(argtab["inframe"],f)
	
	framedir = (argtab["framedir"]!="" ? argtab["framedir"] : "/aftertime/"argtab["story"]"/")
	frame= framepath framedir sprintf(argtab["frame"],f)
	npbframe= framepath framedir sprintf(argtab["npbframe"],f)
	
	npbcmd= sprintf("/eizm/pro/ong1/npb %s %s q",inframe,npbframe)
	cpcmd = cp" "inframe" "frame
	ongcmd = mawk" -f " bot4awk" -v story="argtab["story"]" -v frame="last" "datapath argtab["story"]"/settings"
	
	### replace this with actual onging!!!
	# system("/eizm/pro/ong1/bot4")
	
	if(system(npbcmd)!=0)
		exit 1
	
	if(system(cpcmd)!=0)
		exit 1
	
	print "ONG"
	
	
	print nextstate" "f > statefile
	close(statefile)
	
	system(ongcmd)
}
