// post.cpp (1190.bicyclesonthemoon.info/aftertime/post)
// The post edit interface
// 05.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

#define RM_PATH "/bin/rm"
#define MV_PATH "/bin/mv"
#define CAT_PATH "/bin/cat"
#define MAWK_PATH "/usr/bin/mawk"

#define POST_PATH "/eizm/www/time/aftertime/post.htm"
#define INFO_PATH "/eizm/www/time/aftertime/info.htm"
#define MPOST_PATH "/eizm/mem/aftertime/mpost/"

#define AWK_PREVIEW "/eizm/pro/aftertime/preview.awk"
#define AWK_VIEW "/eizm/pro/aftertime/view.awk"
#define TEMP_PATH "/eizm/tmp/aftertime/preview."
#define AWK_B2H "/eizm/pro/aftertime/bb2html.awk"
#define AWK_VERIFY "/eizm/pro/aftertime/verify.awk"

s_cgi *cgi;
pid_t sub;
int r;
FILE *tempfile;
FILE *postfile;
bool tf=false;
bool pf=false;
char temppath[256]="";
char temppath2[256]="";
char postpath[512]="";

char zero='\0';
char *username = &zero;
char *password = &zero;
char *message = &zero;
char *y = &zero;
char *m = &zero;
char *d = &zero;
char *h = &zero;
char *disable_bbcode = &zero;
char *disable_smilies = &zero;
char *disable_magic_url = &zero;
char *Preview = &zero;
char *post =&zero;
char *addquote =&zero;
char *edit =&zero;
char *forceID =&zero;
char *silent =&zero;
char *story =&zero;
char *frame =&zero;
char *round =&zero;
char *subject =&zero;
char *key =&zero;
char *forcekey =&zero;
char *ID =&zero;

char wrong[256];

void submit();
void preview (const char *text);
void writeArg(FILE *file,const char *name,const char *value, bool all);
void writeArg(FILE *file,const char *name,const char *value, const char *insert);
void writeArgH(FILE *file,const char *name,const char *value, unsigned char br);
void writeArgH(FILE *file,const char *value);
// void writeArgBR(FILE *file,const char *name, const char *value);
void end(int m);
void id(char *timenumber,char *story, unsigned short frame, unsigned char round);

void end(int m)
{
	if(tf)
		fclose(tempfile);
	if(pf)
		fclose(postfile);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath2,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(pf)
	{
		sub=fork();
		if(sub==0)
		{
			r=execl(RM_PATH,RM_PATH,"-f",postpath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	exit(m);
}

void writeArg(FILE *file,const char *name,const char *value, bool all=false)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if(((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')&&(!all))
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArg(FILE *file,const char *name,const char *value, const char *insert)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	for(i=0, length=strlen(insert);i<length;++i)
	{
		v=((unsigned short)insert[i])&0x00ff;
		if((insert[i]>='0'&&insert[i]<='9')||(insert[i]>='A'&&insert[i]<='Z')||(insert[i]>='a'&&insert[i]<='z')
		||insert[i]=='.'||insert[i]=='~'||insert[i]=='-'||insert[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *name,const char *value, unsigned char br=0)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case ' ':
			if(br&0x02)
			{
				fputc(v,file);
				break;
			}
			else
			{
				fprintf(file,"&#%hu;",v);
				break;
			}
		case '\n':
			if(br&0x01)
				fprintf(file,"<br>");
		case '\r':
			if(br&0x01)
				break;
		case '=':
		case '<':
		case '>':
		case '&':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *value)
{
	unsigned short length, i, v;
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case '&':
		case '<':
		case '>':
		case ' ':
		case '\r':
		case '\n':
		case '=':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
}

// void writeArgBR(FILE *file,const char *name, const char *value)
// {
	// unsigned short length, i, v;
	// fprintf(file,"%s=",name);
	// for(i=0, length=strlen(value);i<length;++i)
	// {
		// v=((unsigned short)value[i])&0x00ff;
		// switch (value[i])
		// {
		// case '\n':
			// fprintf(file,"%s","[br]");
		// case '\r':
			// break;
		// default:
			// fputc(v,file);
		// }
	// }
// }

void submit()
{
	// time_t posttime;
	// struct tm *nowS;
	char timenumber[256];
	char forcepath[512];
	char yy[8];
	char ff[8];
	char rr[4]; 
	char mm[4];
	char dd[4];
	char hh[4];
	
	char arg1[256];
	char arg2[256];
	char arg3[256];
	
	char newkey[33];
	
	unsigned char tm, td, th, tr;
	unsigned short ty, tf;

	// posttime=time(NULL);
	// nowS=gmtime(&posttime);
	
	if(forcekey[0]=='\0')
		sprintf(newkey,"%04X%04X%04X%04X%04X%04X%04X%04X",
			(unsigned short)rand(),(unsigned short)rand(),(unsigned short)rand(),(unsigned short)rand(),
			(unsigned short)rand(),(unsigned short)rand(),(unsigned short)rand(),(unsigned short)rand());
	else
		sprintf(newkey,"%s",forcekey);
	
	if(y[0]!='\0'){sscanf(y,"%hu",&ty); sprintf(yy,"%04hu",ty); }
	if(m[0]!='\0'){sscanf(m,"%hhu",&tm);sprintf(mm,"%02hhu",tm);}
	if(d[0]!='\0'){sscanf(d,"%hhu",&td);sprintf(dd,"%02hhu",td);}
	if(h[0]!='\0'){sscanf(h,"%hhu",&th);sprintf(hh,"%02hhu",th);}
	if(frame[0]!='\0'){sscanf(frame,"%hu",&tf);sprintf(ff,"%04hu",tf);}
	if(round[0]!='\0'){sscanf(round,"%hhu",&tr);sprintf(rr,"%02hhu",tr);}
	
	if((ty>0x0fff)||(tm>0x0f)||(td>0x1f)||(th>0x1f))
		preview("Time too long");
	// I accept invalid time as long as it's not too long
	
	id(timenumber,story,tf,tr);
	sprintf(postpath,"%s%s",MPOST_PATH,timenumber);
	if(forceID[0]!='\0')
		sprintf(forcepath,"%s%s",MPOST_PATH,forceID);
	
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		preview("Couldn't create file.");
	tf=true;
	writeArgH(tempfile,"timenumber",timenumber);
	writeArgH(tempfile,"key",newkey);
	writeArgH(tempfile,"username_h",username);
	writeArgH(tempfile,"subject_h",subject);
	writeArgH(tempfile,"story",story);
	if(frame[0]!='\0')writeArgH(tempfile,"frame",ff);
	if(round[0]!='\0')writeArgH(tempfile,"round",rr);
	writeArgH(tempfile,"BBHTML",message,1);
	writeArgH(tempfile,"BB",message,3);
	if(h[0]!='\0')writeArgH(tempfile,"h",hh);
	if(d[0]!='\0')writeArgH(tempfile,"d",dd);
	if(m[0]!='\0')writeArgH(tempfile,"m",mm);
	if(y[0]!='\0')writeArgH(tempfile,"y",yy);
	if(disable_bbcode[0]!='\0')
		writeArg(tempfile,"disable_bbcode",disable_bbcode);
	if(disable_smilies[0]!='\0')
		writeArg(tempfile,"disable_smilies",disable_smilies);
	if(disable_magic_url[0]!='\0')
		writeArg(tempfile,"disable_magic_url",disable_magic_url);
	if(ID[0]!='\0')
		writeArgH(tempfile,"ID",ID);
	fclose(tempfile);
	tf=false;
	
	sprintf(arg1,"outfile=%s",temppath);
	sprintf(arg2,"tempfile=%s",temppath2);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,"-v",arg2,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	sprintf(arg1,"name=%s",username);
	sprintf(arg2,"pass=%s",password);
	sprintf(arg3,"story=%s",story);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VERIFY,"-v",arg1,"-v",arg2,"-v",arg3,"-v","reversed=1",(forceID[0]!='\0')?forcepath:postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(!r)
		preview("Can't submit this post. Not yours or wrong password?");
		
	if(forceID[0]!='\0')
	{
		sub=fork();
		if(sub==0)
		{
			r=execl(RM_PATH,RM_PATH,forcepath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	
	sub=fork();
		if(sub==0)
	{
		r=execl(MV_PATH,MV_PATH,temppath,postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		// preview("Couldn't add post to queue.");
		preview(postpath);
	
	printf("Content-type: text/html\n\n");
	sprintf(arg1,"info=<p>This message has been sent successfully.<br><br><a href=\"/aftertime/view?v=%s&amp;key=%s\">View your submitted message</a><br><br><a href=\"/aftertime/list/\">Return to the list</a></p>",timenumber,newkey);
	// printf("Content-type: text/html\n\n");
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",arg1,INFO_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body>%s</body></html>",arg1);
	end(0);
}
void preview (const char *text)
{
	char arg1[256];
	char arg2[256];
	char yy[8];
	char ff[8];
	char rr[4];
	char mm[4];
	char dd[4];
	char hh[4];
	unsigned short ty, tf;
	unsigned char tm,td,th, tr;
	if(y[0]!='\0'){sscanf(y,"%hu",&ty); ty&=0x0fff;sprintf(yy,"%04hu",ty); }
	if(m[0]!='\0'){sscanf(m,"%hhu",&tm);tm&=  0x0f;sprintf(mm,"%02hhu",tm);}
	if(d[0]!='\0'){sscanf(d,"%hhu",&td);td&=  0x1f;sprintf(dd,"%02hhu",td);}
	if(h[0]!='\0'){sscanf(h,"%hhu",&th);th&=  0x1f;sprintf(hh,"%02hhu",th);}
	if(frame[0]!='\0'){sscanf(frame,"%hu",&tf);sprintf(ff,"%04hu",tf);}
	if(round[0]!='\0'){sscanf(round,"%hhu",&tr);sprintf(rr,"%02hhu",tr);}
	
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		end(1);
	tf=true;
	
	writeArgH(tempfile,"message",message);
	writeArgH(tempfile,"subject",(subject[0]!='\0')?subject:"Did you notice …");
	writeArgH(tempfile,"wrong",text);
	writeArgH(tempfile,"username",username);
	writeArgH(tempfile,"message",message);
	writeArgH(tempfile,"BB",message,3);
	if(h[0]!='\0')writeArgH(tempfile,"h",hh);
	if(d[0]!='\0')writeArgH(tempfile,"d",dd);
	if(m[0]!='\0')writeArgH(tempfile,"m",mm);
	if(y[0]!='\0')writeArgH(tempfile,"y",yy);
	writeArgH(tempfile,"story",story);
	if(frame[0]!='\0')writeArgH(tempfile,"frame",ff);
	writeArgH(tempfile,"round",(round[0]!='\0')?rr:"1");
	writeArgH(tempfile,"disable_bbcode",disable_bbcode);
	writeArgH(tempfile,"disable_smilies",disable_smilies);
	writeArgH(tempfile,"disable_magic_url",disable_magic_url);
	writeArgH(tempfile,"addquote",addquote);
	writeArgH(tempfile,"edit",edit);
	writeArgH(tempfile,"forceID",forceID);
	writeArgH(tempfile,"key",forcekey);
	writeArgH(tempfile,"ID",ID);
	fclose(tempfile);
	tf=false;
	
	printf("Content-type: text/html\n\n");
	
	sprintf(arg1,"outfile=%s",temppath);
	sprintf(arg2,"tempfile=%s",temppath2);
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,"-v",arg2,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	// printf("Content-type: text/html\n\n");
	sprintf(arg1,"argfile=%s",temppath);
	sprintf(arg2,"key=%s",key[0]?key:"???");
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		// setvbuf(stdout, NULL, _IONBF, 0);
		// dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_PREVIEW,"-v",arg1,"-v",arg2,POST_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body><p>Ch*rpin* M*stard</p></body></html>");
	end(0);
}

int main()
{
	bool missing=false;
	
	char *arg;
	
	cgi=cgiInit();
	srand (time (NULL) + getpid());
	
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(temppath2,"%s_%lu",TEMP_PATH,(unsigned long)getpid());
	
	arg=cgiGetValue(cgi,"password");
	if(arg!=NULL)
		password=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Password is missing.");
	}
	
	arg=cgiGetValue(cgi,"username");
	if(arg!=NULL)
		username=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Name is missing.");
	}
	
	arg=cgiGetValue(cgi,"story");
	if(arg!=NULL)
	{
		story=arg;
		if(!strcmp(story,"t1i"));
		else if(!strcmp(story,"bftf"));
		else if(!strcmp(story,"zodiac"));
		else
		{
			missing=true;
			strcpy(wrong,"Wrong story name.");
		}
	}
	else
	{
		missing=true;
		strcpy(wrong,"Story name is missing.");
	}
	
	arg=cgiGetValue(cgi,"frame");
	if(arg!=NULL)
		frame=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Frame number is missing.");
	}
	
	arg=cgiGetValue(cgi,"round");
	if(arg!=NULL)
		round=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Round number was missing. Replaced with default value.");
	}
	arg=cgiGetValue(cgi,"subject");
	if(arg!=NULL)
		subject=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Subject was missing. Replaced with default value.");
	}
	
	arg=cgiGetValue(cgi,"message");
	if(arg!=NULL)
		message=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Post is empty.");
	}
	
	
	arg=cgiGetValue(cgi,"y");
	if(arg!=NULL)
		y=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"m");
	if(arg!=NULL)
		m=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"d");
	if(arg!=NULL)
		d=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"h");
	if(arg!=NULL)
		h=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"disable_bbcode");
	if(arg!=NULL)
		disable_bbcode=arg;
	
	arg=cgiGetValue(cgi,"disable_smilies");
	if(arg!=NULL)
		disable_smilies=arg;
	
	arg=cgiGetValue(cgi,"disable_magic_url");
	if(arg!=NULL)
		disable_magic_url=arg;
	
	arg=cgiGetValue(cgi,"Preview");
	if(arg!=NULL)
		Preview=arg;
	
	arg=cgiGetValue(cgi,"post");
	if(arg!=NULL)
		post=arg;
		
	arg=cgiGetValue(cgi,"q");
	if(arg!=NULL)
		addquote=arg;
	
	arg=cgiGetValue(cgi,"e");
	if(arg!=NULL)
		edit=arg;
	
	arg=cgiGetValue(cgi,"forceID");
	if(arg!=NULL)
		forceID=arg;
	
	arg=cgiGetValue(cgi,"key");
	if(arg!=NULL)
		key=arg;
	
	arg=cgiGetValue(cgi,"forcekey");
	if(arg!=NULL)
		forcekey=arg;
		
	arg=cgiGetValue(cgi,"ID");
	if(arg!=NULL)
		ID=arg;
	
	if(strcmp(post,"Submit")==0)
	{
		if(missing)
			preview(wrong);
		else
			submit();
	}
	else
		preview("");
	
	return 0;
	
}

void id(char *timenumber,char *story, unsigned short frame, unsigned char round)
{
	sprintf(timenumber,"%s-%04hu-%02hhu",story,frame,round);
} 