// posted.c (1190.bicyclesonthemoon.info/aftertime/list)
// Display the post list
// 29.03.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define TEMP_PATH "/eizm/tmp/aftertime/posted."
#define POST_PATH "/eizm/mem/aftertime/mpost/"
#define LS_PATH "/bin/ls"
#define RM_PATH "/bin/rm"
#define MAWK_PATH "/usr/bin/mawk"
#define AWK_POSTED "/eizm/pro/aftertime/posted.awk"

s_cgi *cgi;
pid_t sub;
int r;

int main(int argc, char **argv)
{
	char temppath[256]="";
	char line[512];
	char filename[512];
	char postpath[512];
	char argp1[256];
	char argp2[256];
	FILE *tempfile;
	// FILE *postfile;
	unsigned char i;
	// unsigned char sent;
	char zero='\0';
	char *value;
	char *username;
	char *password;
	// dup2(fileno(stdout),fileno(stderr));
	cgi=cgiInit();
	
	username=((value=cgiGetValue(cgi,"username"))?value:&zero);
	password=((value=cgiGetValue(cgi,"password"))?value:&zero);
	// sent=cgiGetValue(cgi,"sent");
	sprintf(argp1,"name=%s",username);
	sprintf(argp2,"pass=%s",password);
	
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	printf("<html lang=\"en\"><head>\n");
	printf("<title>time after Time &bull; Bicycles on the Moon</title>\n");
	printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
	printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	printf("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n");
	printf("<h1>time after Time</h1>\n");
	// printf("(<a href=\"/silentbot/view?v=st0_1\">some explanation</a>)<br>\n");
	printf("<form method=\"post\" action=\"/aftertime/list\"><table>\n");
	printf("<tr><td><b>Username: </b></td><td><input type=\"text\" name=\"username\" class=\"pt\" value=\"%s\"></td></tr>\n",username);
	printf("<tr><td><b>Password: </b></td><td><input type=\"text\" name=\"password\" class=\"pt\"></td></tr>\n");
	printf("<tr><td></td><td><input type=\"submit\" class=\"pk\" value=\"Reload list\"></td></tr></table></form>\n");
	printf("<b><a href=\"/aftertime/post\">Write a post</a></b><br><br>\n");
	printf("<form action=\"/aftertime/upload\" method=\"post\" enctype=\"multipart/form-data\">\n");
	printf("<input type=\"submit\" class=\"pk\" value=\"Upload a file:\"><input type=\"file\" name=\"up\"><br><!-- (<a href=\"#\">file format</a> - <b class=\"br\">23.03.2015</b>) --></form><br><br>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",POST_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No messages.<br>\n");
	else
	{
		printf("<table class=\"pl\"><tr class=\"pls\"><td colspan=\"4\">Waiting</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">ID</td><td class=\"plk\">post time</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		if(password!=NULL)
		{
			tempfile=fopen(temppath,"rt");
			if(tempfile!=NULL)
			{
				for(i=0; fgets(line,511,tempfile)!=NULL; ++i)
				{
					sscanf(line,"%s",filename);
					sprintf(postpath,"%s%s",POST_PATH,filename);
					
					fflush(stdout);
					sub=fork();
					if(!sub)
					{
						r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v",argp1,"-v",argp2,postpath,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					if(r)
						--i;
					
				}
				fclose(tempfile);
			}
		}
		printf("</table><br>\n");

	}
	
	printf("<br><a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	return 0;
}
