#// viewer.awk
#// The viewer
#// 16.09.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.


BEGIN{
	FS=""
	noticepath="/eizm/mem/aftertime/mpost/"
	framepath="/eizm/www/time/"
	datapath="/eizm/data/aftertime/"
	timecmd="date -u +\"%Y%m%d%H\""
	timecmd2="date +\"%H%M%S\""
	botcastleurl="http://1190.bicyclesonthemoon.info"
	
	storytab[0]="time"
	storytab[1]="prickly"
	storytab[2]="potm"
	storytab[3]="lucky"
	storytab[4]="beany"
	storytab[5]="bean2"
	storytab[6]="t1i"
	storytab[7]="zodiac"
	storytab[8]="bftf"
	storytab[9]="t-1"
	
	
	storyname[0]="Time"
	storyname[1]="Prickly"
	storyname[2]="POTM"
	storyname[3]="Lucky"
	storyname[4]="Beanie chapter 1"
	storyname[5]="Beanie chapter 2"
	storyname[6]="t1i"
	storyname[7]="Zanclean Zodiac"
	storyname[8]="BFTF"
	storyname[9]="t-1"
	
	stories=10
	
	if(frame ~ /[a-zA-Z]$/)
	{
		f=int(substr(frame,1,length(frame)-1))
		s=substr(frame, length(frame))
	}
	else
	{
		f=int(frame)
		s=""
	}
	e=int(enhance)
	n=int(notice)
	b=int(bbcode)
	
	timecmd | getline thistime
		close(timecmd)
	
	timecmd2 | getline thistime2
		close(timecmd2)
	
	lastalt=0
	
	ch2num[0]=""
	num2ch[""]=0
	for(i=1;i<=26;++i)
	{
		ch=sprintf("%c",i+96)
		num2ch[i]=ch
		ch2num[ch]=i
	}
	alttabsize=0
}
{
	file=1
	gsub(/[\r\n]/, "", $0)
	eq=index($0, "=")
	if($0 ~ /^[0-9]+=/)
	{
		i=int(substr($0, 1, eq-1))
		alttab[alttabsize]=substr($0, eq+1)
		alttabn[alttabsize]=i
		++alttabsize
		
		# i=int(substr($0, 1, eq-1))
		# if(f>=i && i>=lastalt)
		# {
			# alt=substr($0, eq+1)
			# lastalt=i
		# }
	}
	else if($0 ~ /^sf-[0-9]+=/)
	{
		sf=1
		i=int(substr($0, 4, eq-4))
		if(i==f)
			this_sf= tolower(substr($0, eq+1))
		if(i==f-1)
			prev_sf=tolower(substr($0, eq+1))
			
	}
	argtab[substr($0, 1, eq-1)]=substr($0, eq+1)
}
END{
	
	if (file=="")
		exit 1
	
	if(this_sf=="")
		s=""
	else if(s>this_sf && argtab["cfrt"]=="")
		s=this_sf
	
	ongoing=int(argtab["ongoing"])
	if(ongoing>0)
	{
		statefile= datapath argtab["story"]"/ongstate"
		getline temp < statefile
		close(statefile)
		
		split(temp, temptab, " ")
		state=int(temptab[1])
		last=int(temptab[2])
	}
	else
	{
		last=int(argtab["last"])
		state=3
	}
	first=int(argtab["first"])
	
	if(frame=="")
	{
		if(ongoing>0)
		{
			f=last
			if(ongoing<2)
				onlyframe=1
			else
				onlyframe=""
		}
		else
		{
			f=first
			onlyframe=""
		}
	}
	
	if(f<first && argtab["cfrt"]=="")
		f=first
	
	if(f>last && argtab["cfrt"]=="")
		f=last
		
	for(i=0; i<alttabsize; ++i)
	{
		if(f>=alttabn[i] && alttabn[i]>=lastalt)
		{
			alt=alttab[i]
			lastalt=alttabn[i]
		}
	}
	
	framedir= (argtab["framedir"]!="" ? argtab["framedir"] : "/aftertime/"argtab["story"]"/")
	if(sf!="")
	{
		title=sprintf(argtab["title"(e>0 ? "-"e : "")],f,s)
		frame=framedir sprintf(argtab["frame"(e>0 ? "-"e : "")],f,s)
		if (system("[ -f " framepath frame" ]")!=0)
		{
			frame= framedir sprintf(argtab["frame"],f,s)
			noenh=1
		}
		otherviewerurl=sprintf(argtab["otherviewerurl"], f+int(argtab["othervieweroffset"]),s)
	}
	else
	{
		s=""
		title=sprintf(argtab["title"(e>0 ? "-"e : "")],f)
		frame= framedir sprintf(argtab["frame"(e>0 ? "-"e : "")],f)
		if (system("[ -f " framepath frame" ]")!=0)
		{
			frame= framedir sprintf(argtab["frame"],f)
			noenh=1
		}
		otherviewerurl=sprintf(argtab["otherviewerurl"], f+int(argtab["othervieweroffset"]))
	}
	
	dynamicframe="/aftertime/frame?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s
	
	if((f>last || f<first || (this_sf!="" && s>this_sf)) && argtab["cfrt"]!="")
		frame= framedir argtab["cfrt"]
	
	border= int(argtab["border"])
	width= int(argtab["width"]) + 2*border
	max_enhance=int(argtab["enhance"])
	
	nextf=nextframe()
	prevf=prevframe()
	
	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">"
	print "<html lang=\"en\"><head>"
	print "<title>"title" &bull; time after Time viewer &bull; Bicycles on the Moon</title>"
	print "<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">"
	print "<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">"
	print "<link rel=\"stylesheet\" href=\"/css/botm.css\">"
	print "</head><body><center>"
	print "<a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a><br>"
	print "<H1>"title"</H1>"
	print "<table cellspacing=\"0\" cellpadding=\"0\" width=\""width"\">"
	print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">"
	if(onlyframe!="")
		print "<a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s"\">"
	print "<img src=\""((ongoing>0 && state <2 && f==last)?dynamicframe:frame)"\" alt=\""title"\" title=\""alt"\" border=\""border"\">"
	if(onlyframe!="")
		print "</a>"
	print "</td></tr>"
	
	if(ongoing==1)
	{
		if(state<3)
		{
			ongtime=int(argtab["ongtime"])
			dt = (3600*ongtime - ( int(substr(thistime2,5,2)) + 60*int(substr(thistime2,3,2)) + 3600*( int(substr(thistime2,1,2))%int(argtab["ongtime"]) ) ))%(ongtime*3600)
			ss=(dt>0 ? sprintf("%02u",dt%60) : "NG")
			mm=sprintf("%02u",int(dt/60)%60)
			hh=sprintf("%02u",int(dt/3600))
		}
		else
		{
			ss="E"
			mm="E"
			hh="E"
		}
		timecolor=(state>1?"br":"ni")
		print "<tr width=\""width"\" align=\"right\"><td colspan=\"4\" width=\"100%\"><tt>"
		print "<b class=\""timecolor"\">"hh"</b>:<b class=\""timecolor"\">"mm"</b>:<b class=\""timecolor"\">"ss"</b>"
		print "</tt></td></tr>"
	}
	
	if(onlyframe=="")
	{
		if(max_enhance>0)
		{
			print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">["
			for(i=0;i<=max_enhance;++i)
			{
				if(i!=0)
					print "|"
				if(i==e)
					print"<b>"argtab["enhance-"i]"</b>"
				else
					print"<a href=\"/aftertime/viewer?story="argtab["story"]"&amp;e="i"&amp;f="f s"\">"argtab["enhance-"i]"</a>"
			}
			print "]</td></tr>"
		}
		
		print "<tr width=\""width"\" align=\"center\">"
		print "<td width=\"25%\"><a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="first"\">|&lt; "first"</a></td>"
		print "<td width=\"25%\">"(f>first?"<a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="prevf"\">&lt; "prevf"</a>":"")"</td>"
		print "<td width=\"25%\">"(f<last?"<a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="nextf"\">"nextf" &gt;</a>":"")"</td>"
		print "<td width=\"25%\"><a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="last"\">"last" &gt;|</a></td>"
		print "</tr>"
		
		for(i=0; i<=n; ++i)
		{
			noticepost=noticepath argtab["story"]"-"sprintf("%04u",f)"-"sprintf("%02u",i+1)
			split("", noticetab, ":")
			for(j=0;(getline line < noticepost)>0;++j)
			{
				gsub(/[\r\n]/,"",line)
				eq=index(line,"=")
				noticetab[substr(line, 1, eq-1)]=substr(line, eq+1)
			}
			if(j==0)
				break;
			nposttime=noticetab["y"]noticetab["m"]noticetab["d"]noticetab["h"]
			if (thistime<nposttime)
				break;
			if(i<n)
			{
				print "<tr width=\""width"\"><td colspan=\"4\" width=\"100%\"><i>"noticetab["subject_h"]"</i> "(noticetab["ID"]!=""?"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(<a href=\"/ott/view?p="noticetab["ID"]"#p"noticetab["ID"]"\">OTT time travel</a>)":"")"</td></tr>"
				print"<tr width=\""width"\"><td colspan=\"4\" width=\"100%\">"((noticetab["HTML"]!="")?noticetab["HTML"]:noticetab["BBHTML"])"</td></tr>"
			}
			else
			{
				print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\"><a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s"&amp;n="i+1"\">"noticetab["subject_h"]"</a></td></tr>"
			}
		}
		
		if(b>0)
		{
			print "<tr width=\""width"\"><td colspan=\"4\" width=\"100%\">"
			print"<code>[url="botcastleurl"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s"][img]"botcastleurl frame"[/img][/url]"(b>1 && alt!=""?"[spoiler]"alt"[/spoiler]":"")
			print"</code></td></tr>"
			if(ongoing>0 && state>0 && f==last && b==(alt!=""?2:1))
			{
				print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">"
				print "<form method=\"post\" action=\"/aftertime/pleaseongthis\">"
				print "[<input type=\"submit\" class=\"hl\" value=\"ONG this for me\">]"
				print "<input type=\"hidden\" name=\"story\" value=\""argtab["story"]"\">"
				if(e>0 && noenh=="")
					print "<input type=\"hidden\" name=\"e\" value=\""e"\">"
				print "</form></td></tr>"
			}
			if(b==1 && alt!="")
				print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">[<a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s"&amp;b=2\">spoiler</a>]</td></tr>"
		}
		else
			print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">[<a href=\"/aftertime/viewer?story="argtab["story"](max_enhance>0?"&amp;e="e:"")"&amp;f="f s"&amp;b=1\">bbcode</a>]</td></tr>"
		
		if(argtab["otherviewerurl"]!="")
			print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\">[<a href=\""otherviewerurl"\">"argtab["otherviewertext"]"</a>]</td></tr>"
		
		print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\"><form method=\"get\" action=\"/aftertime/viewer\">Go to frame:"
		print "<input type=\"hidden\" name=\"story\" value=\""argtab["story"]"\">"
		if(max_enhance>0)
			print "<input type=\"hidden\" name=\"e\" value=\""e"\">"
		print "<input class=\"pt\" type=\"text\" name=\"f\" size=\"4\">"
		print "<input class=\"pk\" type=\"submit\" value=\"GO\"></form></td></tr>"
		
		print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\"><form method=\"get\" action=\"/aftertime/viewer\">Go to story:<select class=\"pk\" name=\"story\">"
		for(i=0; i<stories; ++i)
			print "<option value=\""storytab[i]"\""(storytab[i]==argtab["story"]?" selected":"")">"storyname[i]"</option>"
		print "</select> <input class=\"pk\" type=\"submit\" value=\"GO\"></form></td></tr>"
		
		print "<tr width=\""width"\" align=\"center\"><td colspan=\"4\" width=\"100%\"><a href=\"http://1190.bicyclesonthemoon.info/aftertime\">Aftertime ONGsystem</a></td></tr>"
	}
	print "</table>"
	
	print "<br><a href=\"/\">1190.bicyclesonthemoon.info</a>"
	print "</center></body></html>"
	
	
}
function nextframe()
{
	if(this_sf=="")
		return f+1
	else if(s=="")
		return f"a"
	else if(s>=this_sf)
		return f+1
	else
		return f num2ch[ch2num[s]+1]
}
function prevframe()
{
	if(this_sf!="" && s!="")
		return f num2ch[ch2num[s]-1]
	else if(prev_sf!="")
		return (f-1) prev_sf
	else
		return f-1
}